Sort

Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2377    Accepted Submission(s): 610

Problem Description
Recently, Bob has just learnt a naive sorting algorithm: merge sort. Now, Bob receives a task from Alice.
Alice will give Bob N sorted sequences, and the i-th sequence includes ai elements. Bob need to merge all of these sequences. He can write a program, which can merge no more than k sequences in one time. The cost of a merging operation is the sum of the length of these sequences. Unfortunately, Alice allows this program to use no more than T cost. So Bob wants to know the smallest k to make the program complete in time.
 
Input
The first line of input contains an integer t0, the number of test cases. t0 test cases follow.
For each test case, the first line consists two integers N (2≤N≤100000) and T (∑Ni=1ai<T<231).
In the next line there are N integers a1,a2,a3,...,aN(∀i,0≤ai≤1000).
 
Output
For each test cases, output the smallest k.
 
Sample Input
1
5 25
1 2 3 4 5
 
Sample Output
3
 
Source
题目链接:HDU 5884

这题容易想到二分答案K来做,但是仅仅是这样用手写的堆的也是超时的,加了输入外挂也没卡过去(T_T),显然这样的复杂度是NLogN * LogN ,数据一大就T了

然后膜了一下别人的方法:由于每一次拿k-1个数和1个数合并,因此会剩下(n-1)%(k-1)个数,因此用(k-1)-(n-1)%(k-1)个0与(n-1)%(k-1)个剩下的数凑成k-1个数,这样一来最后就一定一次性完全合并,因此先向qa输入(k-1)-(n-1)%(k-1)个0,再把先把原数组排序再放到qa中,qa用来保存未经过合并的数字,qb用来维护合并过程中的数字,这样K叉哈夫曼树的WPL计算方法就成了每一次从这两个队列中取出队头最小的一个元素,取K个,这样就是一次合并,那么合并的复杂度就成了O(N),总复杂度变成了N * LogN 这里算是学到了一个计算WPL的技巧。

代码:

#include <stdio.h>
#include <bits/stdc++.h>
using namespace std;
#define INF 0x3f3f3f3f
#define LC(x) (x<<1)
#define RC(x) ((x<<1)+1)
#define MID(x,y) ((x+y)>>1)
#define CLR(arr,val) memset(arr,val,sizeof(arr))
#define FAST_IO ios::sync_with_stdio(false);cin.tie(0);
typedef pair<int, int> pii;
typedef long long LL;
const double PI = acos(-1.0);
const int N = 100010;
struct Que
{
LL arr[N << 1];
int l, r;
void init()
{
l = r = 0;
}
void push(const LL &val)
{
arr[r++] = val;
}
void pop()
{
++l;
}
inline LL front()
{
return arr[l];
}
inline bool empty()
{
return l == r;
}
};
Que qa, qb;
LL arr[N];
int n;
LL T; bool check(const int &k)
{
qa.init();
qb.init();
int res = (n - 1) % (k - 1);
if (res)
{
res = (k - 1) - res;
while (res--)
qa.push(0LL);
}
for (int i = 1; i <= n; ++i)
qa.push(arr[i]); LL sum = 0LL;
while ((!qa.empty()) || (!qb.empty()))
{
LL temp = 0LL;
for (int i = 0; i < k; ++i)
{
if (qa.empty() && qb.empty())
break;
if (!qa.empty() && !qb.empty())
{
if (qa.front() < qb.front())
{
temp += qa.front();
qa.pop();
}
else
{
temp += qb.front();
qb.pop();
}
}
else if (!qa.empty())
{
temp += qa.front();
qa.pop();
}
else if (!qb.empty())
{
temp += qb.front();
qb.pop();
}
}
sum += temp;
if (qa.empty() && qb.empty())
break;
qb.push(temp);
}
return sum <= T;
}
int main(void)
{
int tcase, i;
scanf("%d", &tcase);
while (tcase--)
{
scanf("%d%I64d", &n, &T);
for (i = 1; i <= n; ++i)
scanf("%I64d", arr + i);
sort(arr + 1, arr + 1 + n);
int L = 2, R = n;
int k = 1;
while (L <= R)
{
int mid = (L + R) >> 1;
if (check(mid))
{
k = mid;
R = mid - 1;
}
else
L = mid + 1;
}
printf("%d\n", k);
}
return 0;
}

HDU 5884 Sort(二分答案+计算WPL的技巧)的更多相关文章

  1. HDU 5884 Sort (二分)

    题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5884 nn个有序序列的归并排序.每次可以选择不超过kk个序列进行合并,合并代价为这些序列的长度和.总的 ...

  2. HDU 5884 Sort (二分+k叉哈夫曼树)

    题意:n 个有序序列的归并排序.每次可以选择不超过 k 个序列进行合并,合并代价为这些序列的长度和.总的合并代价不能超过T, 问 k最小是多少. 析:首先二分一下这个 k .然后在给定 k 的情况下, ...

  3. HDU - 5884 Sort (二分答案+贪心)

    有n个数字,你需要把这n个数字合成一个数字,每次只能把k个数字合并成一个,花费为这k个数字的和. 给一个最大花费,问不超过这个最大花费的情况下,k的最小值. Sample Input 1 5 25 1 ...

  4. Sort HDU - 5884(优先队列+二分)

    Sort Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submis ...

  5. U - Inviting Friends HDU - 3244(二分答案 + 完全背包)

    U - Inviting Friends HDU - 3244 You want to hold a birthday party, inviting as many friends as possi ...

  6. HDU 5884 Sort(2016年青岛网络赛 G 二分+贪心+小优化)

    好题 题意:给你n<=100000个数,每个数范围[0,1000],然后给你一个最大的代价T,每次最多合并k个数成为一个数,代价为k个数的总和.问最后合成1个数的总代价不大于T的最小k 题解:我 ...

  7. HDU 5884 Sort(二分+优先队列)

    http://acm.hdu.edu.cn/showproblem.php?pid=5884 题意:有个屌丝设计了一个程序,每次可以将k个数组进行合并,代价为这k个数组总的长度之和.现在另外一个屌丝要 ...

  8. 【最优K叉树】hdu 5884 Sort

    http://acm.hdu.edu.cn/showproblem.php?pid=5884 参考:https://www.cnblogs.com/jhz033/p/5879452.html [题意] ...

  9. noiac64 sort (二分答案)

    首先如果L=1,那就可以直接用一个优先队列来做 但它并不是1 所以要换个做法 假设我们已经知道第L的数是x,第R的数是y 那其实就只需要找到[x+1,y+1]这一段,然后再加上一定数量的x和y就是答案 ...

随机推荐

  1. geoWithin查询 多边形查询

    $geoWithin查询 形状的表示 .$box:矩形,使用 {$box:[[<x1>,<y1>],[<x2>,<y2>]]}表示 都是坐标,第一个坐标 ...

  2. wu2198:难得的波段抄底机会

    很好的波段抄底机会 个人浅见看,目前染料股跌出的机会明显,养殖股波段机会明显,芯片.半导体.集成电路.北导.软件.国产操作系统等科技股短线机会不错.另外,大盘指数2856/2806区域的波段操作机会不 ...

  3. 使ListView控件中的选择项高亮显示

    实现效果: 知识运用: ListView控件的SelectedItems属性 //获取在ListView控件中被选中数据项的集合 public ListView.SelectedListViewIte ...

  4. js 常用工具类

    /** * 存储sessionStorage */const setStore = (name, content) => { window.sessionStorage.setItem(name ...

  5. java 如何使的float保留2位或者多位小数

    方法1: float   f   =  34.232323;     BigDecimal   b  =   new  BigDecimal(f);     float   f1   =  b.set ...

  6. Python求包含数字或字母最长的字符串及长度

    一.求包含数字或字母最长的字符串及长度 org = 'ss121*2222&sdfs2!aaabb' result = [] #保存最终要输出的字符串 result_temp = [] #保存 ...

  7. [转] 防止js全局变量污染方法总结

    javaScript 可以随意定义保存所有应用资源的全局变量.但全局变量可以削弱程序灵活性,增大了模块之间的耦合性.在多人协作时,如果定义过多的全局变量 有可能造成全局变量冲突,也就是全局变量污染问题 ...

  8. 毛毛虫组【Beta】Scrum Meeting 2

    第二天 日期:2019/6/24 前言 第二次会议: 时间:6月24日 地点:教10-503 内容:此次会议主要是进一步完善系统,分配进行文档的准备工作. 1.1 今日完成任务情况以及遇到的问题. 今 ...

  9. ERR_FAILED 浏览器访问

    我是针对上一篇的问题 继续的探究  ,我百度了 看了这 https://zhidao.baidu.com/question/1175643597811783659.html 之后我就用 电脑管家进行系 ...

  10. Luogu [P1248] 加工生产调度

    题目链接 这个题可以贪心 我们首先想:对于所有产品,我们大致可以将其分为三类: ①.在A车间的时间要比B车间长. ②.两者一样. ③.在B车间的时间要比A车间长. 对于这三大类,怎么安排顺序? 可以看 ...